
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_minimum -1.0
#property indicator_maximum 1.0
#property indicator_buffers 3
#property indicator_color1 DimGray
#property indicator_color2 DimGray
#property indicator_color3 Red

extern int trendPeriod = 20;
extern string TimeFrame = "Current time frame";
double buffer6[];
double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
int array_tf[];
int timeFrame;
string IndicatorFileName;

int init() {
   IndicatorBuffers(6);
   SetIndexBuffer(0, buffer1);
   SetIndexBuffer(1, buffer2);
   SetIndexBuffer(2, buffer6);
   SetIndexBuffer(3, buffer3);
   SetIndexBuffer(4, buffer4);
   SetIndexBuffer(5, buffer5);
   SetIndexLabel(0, NULL);
   SetIndexLabel(1, NULL);
   SetIndexLabel(2, "Trend direction & force");
   IndicatorFileName = WindowExpertName();
   timeFrame = stringToTimeFrame(TimeFrame);
   IndicatorShortName("Trend direction & force" + TimeFrameToString(timeFrame) + " (" + trendPeriod + ")");
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   double ld_0;
   double ld_8;
   double ld_16;
   double ld_24;
   double ld_32;
   int i;
   int k;
   int counted_bars = IndicatorCounted();
   if (counted_bars < 0) return (-1);
   if (counted_bars > 0) counted_bars--;
   int limit = Bars - counted_bars;
   if (timeFrame != Period()) {
      limit = MathMax(limit, timeFrame / Period());
      ArrayCopySeries(array_tf, 5, NULL, timeFrame);
      i = 0;
      k = 0;
      while (i < limit) {
         if (Time[i] < array_tf[k]) k++;
         buffer6[i] = iCustom(NULL, timeFrame, IndicatorFileName, trendPeriod, 2, k);
         buffer1[i] = 0.05;
         buffer2[i] = -0.05;
         i++;
      }
      return (0);
   }
   for (i = limit; i >= 0; i--) buffer3[i] = iMA(NULL, 0, trendPeriod, 0, MODE_EMA, PRICE_CLOSE, i);
   for (i = limit; i >= 0; i--) {
      buffer4[i] = iMAOnArray(buffer3, 0, trendPeriod, 0, MODE_EMA, i);
      ld_0 = buffer3[i] - (buffer3[i + 1]);
      ld_8 = buffer4[i] - (buffer4[i + 1]);
      ld_16 = MathAbs(buffer3[i] - buffer4[i]) / Point;
      ld_24 = (ld_0 + ld_8) / (2.0 * Point);
      buffer5[i] = ld_16 * MathPow(ld_24, 3);
      ld_32 = absHighest(buffer5, 3 * trendPeriod, i);
      if (ld_32 > 0.0) buffer6[i] = buffer5[i] / ld_32;
      else buffer6[i] = 0.0;
      buffer1[i] = 0.05;
      buffer2[i] = -0.05;
   }
   return (0);
}

double absHighest(double ada_0[], int ai_4, int ai_8) {
   double res = 0.0;
   for (int i = ai_4 - 1; i >= 0; i--)
      if (res < MathAbs(ada_0[ai_8 + i])) res = MathAbs(ada_0[ai_8 + i]);
   return (res);
}

int stringToTimeFrame(string tfs) {
   int tf = 0;
   tfs = StringTrimLeft(StringTrimRight(StringUpperCase(tfs)));
   if (tfs == "M1" || tfs == "1") tf = 1;
   if (tfs == "M5" || tfs == "5") tf = 5;
   if (tfs == "M15" || tfs == "15") tf = 15;
   if (tfs == "M30" || tfs == "30") tf = 30;
   if (tfs == "H1" || tfs == "60") tf = 60;
   if (tfs == "H4" || tfs == "240") tf = 240;
   if (tfs == "D1" || tfs == "1440") tf = 1440;
   if (tfs == "W1" || tfs == "10080") tf = 10080;
   if (tfs == "MN" || tfs == "43200") tf = 43200;
   if (tf < Period()) tf = Period();
   return (tf);
}

string TimeFrameToString(int tf) {
   string tfs = "";
   if (tf != Period()) {
      switch (tf) {
      case 1:
         tfs = "M1";
         break;
      case 5:
         tfs = "M5";
         break;
      case 15:
         tfs = "M15";
         break;
      case 30:
         tfs = "M30";
         break;
      case 60:
         tfs = "H1";
         break;
      case 240:
         tfs = "H4";
         break;
      case 1440:
         tfs = "D1";
         break;
      case 10080:
         tfs = "W1";
         break;
      case 43200:
         tfs = "MN1";
      }
      tfs = StringConcatenate(" ", tfs);
   }
   return (tfs);
}

string StringUpperCase(string tfs) {
   int li_20;
   string ls_ret_8 = tfs;
   for (int li_16 = StringLen(tfs) - 1; li_16 >= 0; li_16--) {
      li_20 = StringGetChar(ls_ret_8, li_16);
      if ((li_20 > '`' && li_20 < '{') || (li_20 > '' && li_20 < 256)) ls_ret_8 = StringSetChar(ls_ret_8, li_16, li_20 - 32);
      else
         if (li_20 > -33 && li_20 < 0) ls_ret_8 = StringSetChar(ls_ret_8, li_16, li_20 + 224);
   }
   return (ls_ret_8);
}